with Ada.Text_IO; use Ada.Text_IO;
with Tasks; use Tasks;
with Ada.Task_Identification; 
with GNAT.OS_Lib;

procedure Adatests is
  Total: Natural := 0;
begin
  Put_Line("Creating " & Natural'Image(Max_Tasks) & " tasks.");
  Tasks.Create_Tasks(Max_Tasks);
  
  Total := Count_Alive;
  if Total /= Max_Tasks then
    Put_Line("FAIL: created " & Natural'Image(Total) & " tasks.");
  else
    Put_Line("PASS: created max_tasks.");
  end if;  

  Put_Line("Aborting " & Natural'Image(Max_Tasks) & " tasks.");
  Tasks.Abort_Tasks;
  Total := Count_Alive;
  if Total /= 0 then
    Put_Line("FAIL: after abort: " & Natural'Image(Total) & " tasks alive.");
  else
    Put_Line("PASS: aborted all tasks.");
  end if;  

--  Put_Line("Will try to abort main program via Ada.Task_Identification");  
--  Ada.Task_Identification.Abort_Task(Ada.Task_Identification.Current_Task);

  Put_Line("Will abort main program with C's exit");
  GNAT.OS_Lib.OS_Exit(0);
  Put_Line("MEGA FAIL.");
end Adatests;
