with Ada.Text_IO; use Ada.Text_IO;

package body Tasks is
  task body TestTask is
    Stop: Boolean;
  begin
    loop
      Stop := True;
    end loop;
  end TestTask;

  procedure Create_Tasks(N: in Task_Count) is
  begin
    for I in 1..N loop
      A(I) := new TestTask(I);
    end loop;
  end Create_Tasks;

  procedure Abort_Tasks is
  begin
    for I in A'Range loop
      if A(I)/= null then
        abort A(I).all;
        if A(I)'Terminated and
           (not A(I)'Callable) then
          Put_Line("PASS: Task " & Natural'Image(I) & " aborted.");
        else
          Put_Line("FAIL: Task " & Natural'Image(I) & " NOT aborted.");
        end if;
      end if;
    end loop;
  end Abort_Tasks;

  function Count_Alive return Natural is
    N: Natural := 0;
  begin
    for I in A'Range loop
      if A(I) /= null then
        if A(I)'Callable or
           (not A(I)'Terminated) then
          N := N+1;
        end if;
      end if;
    end loop;
    return N;
  end Count_Alive;


end Tasks;
